angular.module('beamng.apps')
.directive('adjustableFastMotion', ['bngApi', function (bngApi) {
  return {
	template:
	  '<div class="bngApp">' +
	    '<h2 align="center" id="fastmoCount">100%<h2>' +
	    '<md-slider flex step=1 min=100 max=500 ng-model="slowmoslide" aria-label="_" style="padding: 0 5px"></md-slider>' +
	  '</div>',
    replace: true,
    restrict: 'EA',
	controller: ['$scope', function ($scope) {
		$scope.slowmoslide = 100; //Set initial value to 100%
}],
	
    link: function (scope, element, attrs) {  
	  scope.$watch('slowmoslide', function (newVal, oldVal) {
		  document.getElementById("fastmoCount").innerHTML = newVal + "%";
		  if(newVal == 100){
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor(0)' );
		  } else {
			  bngApi.engineLua( 'be:setPhysicsSpeedFactor('+ (newVal.toString()/100) + ')' );
			  bngApi.engineLua( 'bullettime.set('+ (newVal.toString()/100) + ')' );
		  }
	  });
    }
  };
}]);